package com.swt;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.swt", "com.swt.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.swt", "com.swt.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.swt.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static com.stevel05.audiotrack.AudioTracker _at = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _canvas1 = null;
public anywheresoftware.b4a.agraham.threading.Threading _play = null;
public static int _buffersize = 0;
public static int _channelconfig = 0;
public static int _audioformat = 0;
public static float _samplerate = 0f;
public static float _frequency = 0f;
public static int _maxamp = 0;
public static int _maxgain = 0;
public static int _halfmaxamp = 0;
public static int _amplitude = 0;
public static int _gain = 0;
public static short[] _cyclesh = null;
public static byte[] _cycleby = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _freqlbl = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _freqsb = null;
public static int _freqsbmax = 0;
public static int _freqsbmin = 0;
public anywheresoftware.b4a.objects.LabelWrapper _gainlbl = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _gainsb = null;
public anywheresoftware.b4a.objects.ButtonWrapper _playbtn = null;
public anywheresoftware.b4a.objects.LabelWrapper _durlbl = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _dursb = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _sampleratesp = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _samplesizesp = null;
public anywheresoftware.b4a.objects.EditTextWrapper _gainet = null;
public anywheresoftware.b4a.objects.EditTextWrapper _freqet = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 58;BA.debugLine="Activity.LoadLayout(\"1.bal\")";
mostCurrent._activity.LoadLayout("1.bal",mostCurrent.activityBA);
 //BA.debugLineNum = 59;BA.debugLine="Canvas1.Initialize(Panel1)";
mostCurrent._canvas1.Initialize((android.view.View)(mostCurrent._panel1.getObject()));
 //BA.debugLineNum = 62;BA.debugLine="Play.Initialise(\"Play\")";
mostCurrent._play.Initialise(processBA,"Play");
 //BA.debugLineNum = 65;BA.debugLine="MaxGain=100";
_maxgain = (int) (100);
 //BA.debugLineNum = 66;BA.debugLine="GainSB.Max=MaxGain";
mostCurrent._gainsb.setMax(_maxgain);
 //BA.debugLineNum = 68;BA.debugLine="FreqSBMin=40";
_freqsbmin = (int) (40);
 //BA.debugLineNum = 69;BA.debugLine="FreqSBMax=19000";
_freqsbmax = (int) (19000);
 //BA.debugLineNum = 70;BA.debugLine="FreqSB.Max=FreqSBMax-FreqSBMin";
mostCurrent._freqsb.setMax((int) (_freqsbmax-_freqsbmin));
 //BA.debugLineNum = 72;BA.debugLine="Log(\"AT \"&at)";
anywheresoftware.b4a.keywords.Common.Log("AT "+BA.ObjectToString(_at));
 //BA.debugLineNum = 76;BA.debugLine="SampleRateSP.AddAll(Array As String(\"8000\",\"11025\",\"22050\",\"44100\"))";
mostCurrent._sampleratesp.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"8000","11025","22050","44100"}));
 //BA.debugLineNum = 78;BA.debugLine="SampleRateSP.SelectedIndex=3";
mostCurrent._sampleratesp.setSelectedIndex((int) (3));
 //BA.debugLineNum = 79;BA.debugLine="SampleSizeSp.AddAll(Array As String(\"8 Bit\",\"16 Bit\"))";
mostCurrent._samplesizesp.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"8 Bit","16 Bit"}));
 //BA.debugLineNum = 81;BA.debugLine="SampleSizeSp.SelectedIndex=1";
mostCurrent._samplesizesp.setSelectedIndex((int) (1));
 //BA.debugLineNum = 86;BA.debugLine="SampleRate=44100'11025";
_samplerate = (float) (44100);
 //BA.debugLineNum = 87;BA.debugLine="AudioFormat=at.Af_PCM_16'at.Af_PCM_8";
_audioformat = _at.AF_PCM_16;
 //BA.debugLineNum = 88;BA.debugLine="ChannelConfig=at.Ch_Conf_Mono";
_channelconfig = _at.CH_CONF_MONO;
 //BA.debugLineNum = 90;BA.debugLine="Frequency = 440";
_frequency = (float) (440);
 //BA.debugLineNum = 91;BA.debugLine="Gain=100";
_gain = (int) (100);
 //BA.debugLineNum = 93;BA.debugLine="InitAudioTrack";
_initaudiotrack();
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 215;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 216;BA.debugLine="at.Release";
_at.Release();
 //BA.debugLineNum = 217;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 211;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 213;BA.debugLine="End Sub";
return "";
}
public static String  _createsinewave() throws Exception{
float _cyclelength = 0f;
float _cyclefactor = 0f;
String _x = "";
String _i = "";
 //BA.debugLineNum = 136;BA.debugLine="Sub CreateSineWave";
 //BA.debugLineNum = 143;BA.debugLine="Dim CycleLength,CycleFactor As Float";
_cyclelength = 0f;
_cyclefactor = 0f;
 //BA.debugLineNum = 144;BA.debugLine="CycleLength = SampleRate/Frequency   ' = Number of samples per cycle";
_cyclelength = (float) (_samplerate/(double)_frequency);
 //BA.debugLineNum = 147;BA.debugLine="CycleFactor = 360/CycleLength";
_cyclefactor = (float) (360/(double)_cyclelength);
 //BA.debugLineNum = 149;BA.debugLine="If AudioFormat=at.Af_PCM_16 Then";
if (_audioformat==_at.AF_PCM_16) { 
 //BA.debugLineNum = 151;BA.debugLine="Dim CycleSh(CycleLength) As Short";
_cyclesh = new short[(int) (_cyclelength)];
;
 //BA.debugLineNum = 154;BA.debugLine="Dim X=0";
_x = BA.NumberToString(0);
 //BA.debugLineNum = 155;BA.debugLine="Dim i=0";
_i = BA.NumberToString(0);
 //BA.debugLineNum = 157;BA.debugLine="Do While i < 360-CycleFactor";
while ((double)(Double.parseDouble(_i))<360-_cyclefactor) {
 //BA.debugLineNum = 158;BA.debugLine="CycleSh(X)=SinD(i)*Amplitude";
_cyclesh[(int)(Double.parseDouble(_x))] = (short) (anywheresoftware.b4a.keywords.Common.SinD((double)(Double.parseDouble(_i)))*_amplitude);
 //BA.debugLineNum = 159;BA.debugLine="X=X+1";
_x = BA.NumberToString((double)(Double.parseDouble(_x))+1);
 //BA.debugLineNum = 160;BA.debugLine="i=i+CycleFactor";
_i = BA.NumberToString((double)(Double.parseDouble(_i))+_cyclefactor);
 }
;
 }else {
 //BA.debugLineNum = 164;BA.debugLine="Dim CycleBy(CycleLength) As Byte";
_cycleby = new byte[(int) (_cyclelength)];
;
 //BA.debugLineNum = 167;BA.debugLine="X=0";
_x = BA.NumberToString(0);
 //BA.debugLineNum = 168;BA.debugLine="i=0";
_i = BA.NumberToString(0);
 //BA.debugLineNum = 169;BA.debugLine="Do While i < 360-CycleFactor";
while ((double)(Double.parseDouble(_i))<360-_cyclefactor) {
 //BA.debugLineNum = 170;BA.debugLine="CycleBy(X)=SinD(i)*Amplitude";
_cycleby[(int)(Double.parseDouble(_x))] = (byte) (anywheresoftware.b4a.keywords.Common.SinD((double)(Double.parseDouble(_i)))*_amplitude);
 //BA.debugLineNum = 171;BA.debugLine="X=X+1";
_x = BA.NumberToString((double)(Double.parseDouble(_x))+1);
 //BA.debugLineNum = 172;BA.debugLine="i=i+CycleFactor";
_i = BA.NumberToString((double)(Double.parseDouble(_i))+_cyclefactor);
 }
;
 };
 //BA.debugLineNum = 176;BA.debugLine="End Sub";
return "";
}
public static String  _dursb_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 261;BA.debugLine="Sub DurSB_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 262;BA.debugLine="DurLbl.Text=\"Dur : \"&Value";
mostCurrent._durlbl.setText((Object)("Dur : "+BA.NumberToString(_value)));
 //BA.debugLineNum = 263;BA.debugLine="End Sub";
return "";
}
public static String  _freqet_enterpressed() throws Exception{
 //BA.debugLineNum = 294;BA.debugLine="Sub FreqET_EnterPressed";
 //BA.debugLineNum = 295;BA.debugLine="If FreqET.Text < FreqSBMin OR FreqET.Text > FreqSBMax Then";
if ((double)(Double.parseDouble(mostCurrent._freqet.getText()))<_freqsbmin || (double)(Double.parseDouble(mostCurrent._freqet.getText()))>_freqsbmax) { 
 //BA.debugLineNum = 296;BA.debugLine="FreqET.Text=Frequency";
mostCurrent._freqet.setText((Object)(_frequency));
 //BA.debugLineNum = 297;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 299;BA.debugLine="FreqET.Visible=False";
mostCurrent._freqet.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 300;BA.debugLine="FreqSB.Value=FreqET.Text-FreqSBMin";
mostCurrent._freqsb.setValue((int) ((double)(Double.parseDouble(mostCurrent._freqet.getText()))-_freqsbmin));
 //BA.debugLineNum = 301;BA.debugLine="End Sub";
return "";
}
public static String  _freqlbl_click() throws Exception{
 //BA.debugLineNum = 291;BA.debugLine="Sub FreqLbl_Click";
 //BA.debugLineNum = 292;BA.debugLine="FreqET.Visible=True";
mostCurrent._freqet.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 293;BA.debugLine="End Sub";
return "";
}
public static String  _freqsb_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 257;BA.debugLine="Sub FreqSB_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 258;BA.debugLine="Frequency=Value+FreqSBMin";
_frequency = (float) (_value+_freqsbmin);
 //BA.debugLineNum = 259;BA.debugLine="FreqLbl.Text=\"Freq : \"&Frequency";
mostCurrent._freqlbl.setText((Object)("Freq : "+BA.NumberToString(_frequency)));
 //BA.debugLineNum = 260;BA.debugLine="End Sub";
return "";
}
public static String  _gainet_enterpressed() throws Exception{
 //BA.debugLineNum = 280;BA.debugLine="Sub GainET_EnterPressed";
 //BA.debugLineNum = 281;BA.debugLine="If GainET.Text < 0 OR GainET.Text > MaxGain Then";
if ((double)(Double.parseDouble(mostCurrent._gainet.getText()))<0 || (double)(Double.parseDouble(mostCurrent._gainet.getText()))>_maxgain) { 
 //BA.debugLineNum = 282;BA.debugLine="GainET.Text=100";
mostCurrent._gainet.setText((Object)(100));
 //BA.debugLineNum = 283;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 285;BA.debugLine="GainET.Visible=False";
mostCurrent._gainet.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 287;BA.debugLine="GainSB.Value=GainET.Text";
mostCurrent._gainsb.setValue((int)(Double.parseDouble(mostCurrent._gainet.getText())));
 //BA.debugLineNum = 290;BA.debugLine="End Sub";
return "";
}
public static String  _gainlbl_click() throws Exception{
 //BA.debugLineNum = 277;BA.debugLine="Sub GainLbl_Click";
 //BA.debugLineNum = 278;BA.debugLine="GainET.Visible=True";
mostCurrent._gainet.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 279;BA.debugLine="End Sub";
return "";
}
public static String  _gainsb_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 252;BA.debugLine="Sub GainSB_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 253;BA.debugLine="Gain=Value";
_gain = _value;
 //BA.debugLineNum = 254;BA.debugLine="Amplitude=HalfMaxAmp/100*Gain";
_amplitude = (int) (_halfmaxamp/(double)100*_gain);
 //BA.debugLineNum = 255;BA.debugLine="GainLbl.Text=\"Gain : \"&Gain";
mostCurrent._gainlbl.setText((Object)("Gain : "+BA.NumberToString(_gain)));
 //BA.debugLineNum = 256;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim Canvas1 As Canvas";
mostCurrent._canvas1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Dim Play As Thread";
mostCurrent._play = new anywheresoftware.b4a.agraham.threading.Threading();
 //BA.debugLineNum = 27;BA.debugLine="Dim BufferSize As Int";
_buffersize = 0;
 //BA.debugLineNum = 28;BA.debugLine="Dim ChannelConfig As Int";
_channelconfig = 0;
 //BA.debugLineNum = 29;BA.debugLine="Dim AudioFormat As Int";
_audioformat = 0;
 //BA.debugLineNum = 30;BA.debugLine="Dim SampleRate As Float";
_samplerate = 0f;
 //BA.debugLineNum = 31;BA.debugLine="Dim Frequency As Float";
_frequency = 0f;
 //BA.debugLineNum = 32;BA.debugLine="Dim MaxAmp,MaxGain As Int";
_maxamp = 0;
_maxgain = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim HalfMaxAmp As Int";
_halfmaxamp = 0;
 //BA.debugLineNum = 34;BA.debugLine="Dim Amplitude As Int";
_amplitude = 0;
 //BA.debugLineNum = 35;BA.debugLine="Dim Gain As Int";
_gain = 0;
 //BA.debugLineNum = 36;BA.debugLine="Dim CycleSh() As Short";
_cyclesh = new short[(int) (0)];
;
 //BA.debugLineNum = 37;BA.debugLine="Dim CycleBy() As Byte";
_cycleby = new byte[(int) (0)];
;
 //BA.debugLineNum = 39;BA.debugLine="Dim Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim FreqLbl As Label";
mostCurrent._freqlbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Dim FreqSB As SeekBar";
mostCurrent._freqsb = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Dim FreqSBMax,FreqSBMin As Int";
_freqsbmax = 0;
_freqsbmin = 0;
 //BA.debugLineNum = 43;BA.debugLine="Dim GainLbl As Label";
mostCurrent._gainlbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim GainSB As SeekBar";
mostCurrent._gainsb = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Dim PlayBtn As Button";
mostCurrent._playbtn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim DurLbl As Label";
mostCurrent._durlbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim DurSB As SeekBar";
mostCurrent._dursb = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim SampleRateSP As Spinner";
mostCurrent._sampleratesp = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Dim SampleSizeSp As Spinner";
mostCurrent._samplesizesp = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim GainET As EditText";
mostCurrent._gainet = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 52;BA.debugLine="Dim FreqET As EditText";
mostCurrent._freqet = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _initaudiotrack() throws Exception{
 //BA.debugLineNum = 98;BA.debugLine="Sub InitAudioTrack";
 //BA.debugLineNum = 100;BA.debugLine="If at.IsInitialized Then ' has been initialized once already";
if (_at.IsInitialized) { 
 //BA.debugLineNum = 101;BA.debugLine="at.Release";
_at.Release();
 };
 //BA.debugLineNum = 105;BA.debugLine="BufferSize=at.GetMinBuffersize(SampleRate,ChannelConfig,AudioFormat)";
_buffersize = _at.GetMinBuffersize((int) (_samplerate),_channelconfig,_audioformat);
 //BA.debugLineNum = 108;BA.debugLine="at.Initialize(at.Stream_Music,SampleRate,ChannelConfig,AudioFormat,BufferSize,at.Mode_Stream)";
_at.Initialize(processBA,_at.STREAM_MUSIC,(int) (_samplerate),_channelconfig,_audioformat,_buffersize,_at.MODE_STREAM);
 //BA.debugLineNum = 111;BA.debugLine="If at.GetState = 0 Then";
if (_at.GetState()==0) { 
 //BA.debugLineNum = 112;BA.debugLine="Msgbox(\"Failed to initialize AudioTrack Error: \"&at.GetState,\"Initialize Failed\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Failed to initialize AudioTrack Error: "+BA.NumberToString(_at.GetState()),"Initialize Failed",mostCurrent.activityBA);
 //BA.debugLineNum = 113;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 116;BA.debugLine="If AudioFormat=at.Af_PCM_16 Then";
if (_audioformat==_at.AF_PCM_16) { 
 //BA.debugLineNum = 117;BA.debugLine="MaxAmp=65535";
_maxamp = (int) (65535);
 }else {
 //BA.debugLineNum = 119;BA.debugLine="MaxAmp = 256";
_maxamp = (int) (256);
 };
 //BA.debugLineNum = 125;BA.debugLine="HalfMaxAmp=MaxAmp/2";
_halfmaxamp = (int) (_maxamp/(double)2);
 //BA.debugLineNum = 126;BA.debugLine="Amplitude=HalfMaxAmp/100*Gain";
_amplitude = (int) (_halfmaxamp/(double)100*_gain);
 //BA.debugLineNum = 128;BA.debugLine="End Sub";
return "";
}
public static String  _play_ended(boolean _endedok,String _error) throws Exception{
 //BA.debugLineNum = 244;BA.debugLine="Sub Play_Ended(endedOK As Boolean,Error As String)";
 //BA.debugLineNum = 247;BA.debugLine="Play.Sleep(1)";
mostCurrent._play.Sleep((int) (1));
 //BA.debugLineNum = 248;BA.debugLine="CreateSineWave";
_createsinewave();
 //BA.debugLineNum = 249;BA.debugLine="PlotCycle";
_plotcycle();
 //BA.debugLineNum = 250;BA.debugLine="Play.Start(Null,\"PlaySound\",Array As Object(DurSB.Value))";
mostCurrent._play.Start(anywheresoftware.b4a.keywords.Common.Null,"PlaySound",new Object[]{(Object)(mostCurrent._dursb.getValue())});
 //BA.debugLineNum = 251;BA.debugLine="End Sub";
return "";
}
public static String  _playbtn_click() throws Exception{
 //BA.debugLineNum = 129;BA.debugLine="Sub PlayBtn_Click";
 //BA.debugLineNum = 130;BA.debugLine="CreateSineWave";
_createsinewave();
 //BA.debugLineNum = 131;BA.debugLine="PlotCycle";
_plotcycle();
 //BA.debugLineNum = 134;BA.debugLine="Play.Start(Null,\"PlaySound\",Array As Object(DurSB.Value)) 'Me";
mostCurrent._play.Start(anywheresoftware.b4a.keywords.Common.Null,"PlaySound",new Object[]{(Object)(mostCurrent._dursb.getValue())});
 //BA.debugLineNum = 135;BA.debugLine="End Sub";
return "";
}
public static String  _playsound(int _duration) throws Exception{
float _loops = 0f;
double _addl = 0;
int _i = 0;
 //BA.debugLineNum = 177;BA.debugLine="Sub PlaySound(Duration As Int)";
 //BA.debugLineNum = 180;BA.debugLine="at.Play";
_at.Play();
 //BA.debugLineNum = 182;BA.debugLine="at.SetStereoVolume(at.GetMaxVolume,at.GetMaxVolume)";
_at.SetStereoVolume(_at.GetMaxVolume(),_at.GetMaxVolume());
 //BA.debugLineNum = 186;BA.debugLine="Dim Loops As Float";
_loops = 0f;
 //BA.debugLineNum = 187;BA.debugLine="Loops=Frequency*Duration/1000";
_loops = (float) (_frequency*_duration/(double)1000);
 //BA.debugLineNum = 190;BA.debugLine="Dim Addl As Double";
_addl = 0;
 //BA.debugLineNum = 191;BA.debugLine="Addl=Loops-Floor(Loops)";
_addl = _loops-anywheresoftware.b4a.keywords.Common.Floor(_loops);
 //BA.debugLineNum = 193;BA.debugLine="If AudioFormat = at.Af_PCM_16 Then";
if (_audioformat==_at.AF_PCM_16) { 
 //BA.debugLineNum = 195;BA.debugLine="For i = 0 To Loops";
{
final int step107 = 1;
final int limit107 = (int) (_loops);
for (_i = (int) (0); (step107 > 0 && _i <= limit107) || (step107 < 0 && _i >= limit107); _i = ((int)(0 + _i + step107))) {
 //BA.debugLineNum = 196;BA.debugLine="at.WriteShort(CycleSh,0,CycleSh.Length)";
_at.WriteShort(_cyclesh,(int) (0),_cyclesh.length);
 }
};
 //BA.debugLineNum = 199;BA.debugLine="at.WriteShort(CycleSh,0,CycleSh.Length*Addl)";
_at.WriteShort(_cyclesh,(int) (0),(int) (_cyclesh.length*_addl));
 }else {
 //BA.debugLineNum = 202;BA.debugLine="For i = 0 To Loops";
{
final int step112 = 1;
final int limit112 = (int) (_loops);
for (_i = (int) (0); (step112 > 0 && _i <= limit112) || (step112 < 0 && _i >= limit112); _i = ((int)(0 + _i + step112))) {
 //BA.debugLineNum = 203;BA.debugLine="at.WriteByte(CycleBy,0,CycleBy.Length)";
_at.WriteByte(_cycleby,(int) (0),_cycleby.length);
 }
};
 //BA.debugLineNum = 206;BA.debugLine="at.WriteByte(CycleBy,0,CycleBy.Length*Addl)";
_at.WriteByte(_cycleby,(int) (0),(int) (_cycleby.length*_addl));
 };
 //BA.debugLineNum = 209;BA.debugLine="End Sub";
return "";
}
public static String  _plotcycle() throws Exception{
int _dispheight = 0;
int _x = 0;
float _dispfactor = 0f;
float _y = 0f;
int _dispzeropoint = 0;
int _i = 0;
 //BA.debugLineNum = 218;BA.debugLine="Sub PlotCycle";
 //BA.debugLineNum = 220;BA.debugLine="Canvas1.DrawColor(Colors.Gray)";
mostCurrent._canvas1.DrawColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 221;BA.debugLine="Dim DispHeight,X As Int";
_dispheight = 0;
_x = 0;
 //BA.debugLineNum = 222;BA.debugLine="Dim DispFactor As Float";
_dispfactor = 0f;
 //BA.debugLineNum = 223;BA.debugLine="X=0";
_x = (int) (0);
 //BA.debugLineNum = 224;BA.debugLine="Dim Y As Float";
_y = 0f;
 //BA.debugLineNum = 225;BA.debugLine="DispHeight=Panel1.Height";
_dispheight = mostCurrent._panel1.getHeight();
 //BA.debugLineNum = 226;BA.debugLine="DispFactor = DispHeight/MaxAmp";
_dispfactor = (float) (_dispheight/(double)_maxamp);
 //BA.debugLineNum = 227;BA.debugLine="Dim DispZeroPoint=DispHeight/2 As Int";
_dispzeropoint = (int) (_dispheight/(double)2);
 //BA.debugLineNum = 228;BA.debugLine="If AudioFormat = at.Af_PCM_16 Then";
if (_audioformat==_at.AF_PCM_16) { 
 //BA.debugLineNum = 229;BA.debugLine="For i = 0 To CycleSh.Length-1";
{
final int step133 = 1;
final int limit133 = (int) (_cyclesh.length-1);
for (_i = (int) (0); (step133 > 0 && _i <= limit133) || (step133 < 0 && _i >= limit133); _i = ((int)(0 + _i + step133))) {
 //BA.debugLineNum = 230;BA.debugLine="Y=CycleSh(i)*DispFactor+DispZeroPoint";
_y = (float) (_cyclesh[_i]*_dispfactor+_dispzeropoint);
 //BA.debugLineNum = 231;BA.debugLine="Canvas1.DrawPoint(X,Y,Colors.White)";
mostCurrent._canvas1.DrawPoint((float) (_x),_y,anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 232;BA.debugLine="X=X+1";
_x = (int) (_x+1);
 }
};
 }else {
 //BA.debugLineNum = 235;BA.debugLine="For i = 0 To CycleBy.Length-1";
{
final int step139 = 1;
final int limit139 = (int) (_cycleby.length-1);
for (_i = (int) (0); (step139 > 0 && _i <= limit139) || (step139 < 0 && _i >= limit139); _i = ((int)(0 + _i + step139))) {
 //BA.debugLineNum = 236;BA.debugLine="Y=CycleBy(i)*DispFactor+DispZeroPoint";
_y = (float) (_cycleby[_i]*_dispfactor+_dispzeropoint);
 //BA.debugLineNum = 237;BA.debugLine="Canvas1.DrawPoint(X,Y,Colors.White)";
mostCurrent._canvas1.DrawPoint((float) (_x),_y,anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 238;BA.debugLine="X=X+1";
_x = (int) (_x+1);
 }
};
 };
 //BA.debugLineNum = 241;BA.debugLine="Panel1.Invalidate";
mostCurrent._panel1.Invalidate();
 //BA.debugLineNum = 242;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 //BA.debugLineNum = 243;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim at As AudioTrack";
_at = new com.stevel05.audiotrack.AudioTracker();
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _sampleratesp_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 273;BA.debugLine="Sub SampleRateSP_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 274;BA.debugLine="SampleRate = Value";
_samplerate = (float)(BA.ObjectToNumber(_value));
 //BA.debugLineNum = 275;BA.debugLine="InitAudioTrack";
_initaudiotrack();
 //BA.debugLineNum = 276;BA.debugLine="End Sub";
return "";
}
public static String  _samplesizesp_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 264;BA.debugLine="Sub SampleSizeSp_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 265;BA.debugLine="Select Value";
switch (BA.switchObjectToInt(_value,(Object)("8 Bit"),(Object)("16 Bit"))) {
case 0:
 //BA.debugLineNum = 267;BA.debugLine="AudioFormat=at.Af_PCM_8";
_audioformat = _at.AF_PCM_8;
 break;
case 1:
 //BA.debugLineNum = 269;BA.debugLine="AudioFormat=at.Af_PCM_16";
_audioformat = _at.AF_PCM_16;
 break;
}
;
 //BA.debugLineNum = 271;BA.debugLine="InitAudioTrack";
_initaudiotrack();
 //BA.debugLineNum = 272;BA.debugLine="End Sub";
return "";
}
}
